function marg_drap = draper_fcn(epsilon,k)

%
% Computes Draper's (1995) approximation of the marginal likelihood.
% Reference: Draper, D. (1995), "Assessment and Propagation of Model Uncertainty",
%            Journal of the Royal Statistical Society, B, 45-97 (with discussion)
%
% INPUT:
%       epsilon: the residuals for the model
%       k:       the number of parameters
%
% OUTPUT: equation (11) in Draper
%

T = size(epsilon,2);
marg_drap = ((k/2)*(log(2*pi) - log(T)))+loglike(epsilon);

%
% end of draper_fcn.m
%
