function [theta,sigma_theta] = fix_params(Theta,Sigma_theta,beta,d)

%
% fix Theta and Sigma_theta to take restricted constant or restricted linear trend into account
%

if isempty(beta)==0;
   r = size(beta,2);
else;
   return;
end;

if r==0;
   return;
end;

[n num_p] = size(Theta);
rho = beta(size(beta,1),:)';
alpha = Theta(:,num_p-r+1:num_p);

Help_mat = eye(num_p-d);
if num_p-d>r;
   Help_mat = [[zeros(size(Help_mat,1)-r,1);rho] Help_mat];
else;
   Help_mat = [rho Help_mat];
end;

if d>0;
   theta = [Theta(:,1:d) alpha*rho Theta(:,d+1:num_p)];
   Help_mat = [[eye(d) zeros(d,size(Help_mat,2))];[zeros(size(Help_mat,1),d) Help_mat]];
else;
   theta = [alpha*rho Theta];
end;

Help_mat = kron(Help_mat',eye(n));
sigma_theta = Help_mat*Sigma_theta*Help_mat';

%
% end of fix_params.m
%
