function lpr = logprior_rank(delta,Gamma,Omega,alpha,beta,n,r,d,prior_inf_deter,A,q,lambda_alpha,d_mu,d_sigma,G_mu,G_sigma)

%
% computes the value of the density function for the joint prior when investigating the cointegration rank
%

lpr = 0;
if (d>0)&(prior_inf_deter==1);
   lpr = log_normal(delta,vecinv(d_mu,n),d_sigma,Omega);
%   lpr = log_norm(vec(delta),d_mu,kron(d_sigma,Omega));
end;
if isempty(G_mu)==0;
   lpr = lpr + log_normal(Gamma,vecinv(G_mu,n),G_sigma,Omega);
%   lpr = lpr + log_norm(vec(Gamma),G_mu,kron(G_sigma,Omega));
end;
%
% take care of the rest
%
log_cr = ((q/2)*log(det(A))) - (((n*q)/2)*log(2)) - (((n*(n-1))/4)*log(pi)) - (((r*(n-r))/2)*log(pi)) - (((n*r)/2)*log(2*pi*(lambda_alpha^2))) - gamma_product(n,q);
%
add_mat = 0;
if r>0;
   log_cr = log_cr - gamma_product(r,n) - gamma_product(r,r);
   add_mat = (1/(lambda_alpha^2))*alpha*beta'*beta*alpha';
end;
%
log_pa = -(((n+r+q+1)/2)*log(det(Omega))) - ((1/2)*sum(diag( inverse(Omega)*( A + add_mat ) )));
lpr = lpr+log_cr+log_pa;

%
% end of logprior_rank.m
%
