function status = makedirs(thispath,showwait)

%
% if we're on the windows platform
%

if strcmp(computer,'PCWIN')==1;
   if strcmp(thispath(1,size(thispath,2)),'\')==0;
      thispath = [thispath '\'];
   end;
   if direxist(thispath)==1;
      status = 2;
      return;
   end;
   prog = ['bin\makedir.exe ' thispath];
   stat = dos(prog);
   wait_fcn(500);
   if stat==0;
      if direxist(thispath)==1;
         status = 1;
         if fileexist([thispath 'dir-exist.txt'])==1;
            delete_file_fcn([thispath 'dir-exist.txt']);
         end;
      else;
         status = 0;
      end;
   else;
      status = 0;
   end;
   return;
end;

if nargin==1;
   showwait = 1;
end;

%
% function creates directories in
% thispath based on those that do not
% exist. return status 0 if unsuccessful
% and status 1 if successful and status
% 2 if it already exists
%

status = -1;

if nargin==0;
   status = status+1;
   return;
elseif nargin>1;
   status = status+1;
   return;
end;

pathsize = size(thispath,2);
pathmat = '';
oldi = 1;
for i=2:pathsize;
   char = thispath(1,i);
   if strcmp(char,'\')==1;
      newpath = thispath(1,oldi:i);
      if strcmp(pathmat,'')==1;
         pathmat = newpath;
      else;
         pathmat = strvcat(pathmat,newpath);
      end;
      oldi = i+1;
   elseif strcmp(char,'/')==1;
      newpath = thispath(1,oldi:i-1);
      if strcmp(pathmat,'')==1;
         pathmat = newpath;
      else;
         pathmat = strvcat(pathmat,newpath);
      end;
      oldi = i;
   elseif i==pathsize;
      if strcmp(thispath(1,1),'/')==1;
         newpath = thispath(1,oldi:i);
         if strcmp(pathmat,'')==1;
            pathmat = newpath;
         else;
            pathmat = strvcat(pathmat,newpath);
         end;
      elseif strcmp(thispath(1,2:3),':\')==1;
         newpath = strcat(thispath(1,oldi:i),'\');
         if strcmp(pathmat,'')==1;
            pathmat = newpath;
         else;
            pathmat = strvcat(pathmat,newpath);
         end;
      end;
   end;
end;

numpath = size(pathmat,1);
currdir = pwd;

if numpath>=2;
   basedir = pathmat(1,:);
   %
   % show a wait dialog
   %
   if showwait==1;
      wait_hdr = 'Structural VAR is attempting to create:';
   end;
   for i=2:numpath;
      newdir = pathmat(i,:);
      newbasedir = strcat(basedir,newdir);
      newdirsize = size(newdir,2);
      if strcmp(newdir(1,1),'/')==1;
         newdir = newdir(1,2:newdirsize);
      else;
         newdir = newdir(1,1:newdirsize-1);
      end;
      if showwait==1;
         wait_txt = strvcat(' ',wait_hdr,' ',['    ' strtrim(basedir) strtrim(newdir)]);
         if i==2;
            mywait = waitdlg(wait_txt,'explore','Creating Directory',600,120);
            waitf = get(mywait,'UserData');
         else;
            set(waitf.text,'String',wait_txt);
         end;
      end;
      %
      status = mymkdir(basedir,newdir);
      basedir = newbasedir;
      if i==numpath;
         if showwait==1;
            set(waitf.text,'UserData','done');
            delete(mywait);
            drawnow;
         end;
      end;
   end;
end;

%
% end of makedirs.m
%
