function B = matrix_t_rnd(mu,P,Q,n,draw)

if nargin==4;
   draw = 0;
end;

[m s] = size(mu);

S = chol(Q)';
C = chol(inverse(P))';

%
% generate Z such that Z is matricvariate normal with 0 mean and Identity covariance matrix
%
randn('state',sum(100*clock)+draw);
Z = randn(m,s);
%
% generate W such tha WW' is inverted Wishart with parameters I(s) and degrees of freedom n+s
%
[sigma_inv,warn] = wish_rnd(eye(s),n+s,0);
if warn==0;
   sigma = inverse(sigma_inv);
else;
   sigma = eye(s);
end;
W = chol(sigma)';
%
% return B
%

B = mu+(C*Z*W'*S');

%
% end of matrix_t_rnd.m
%
