function res = posterior_rank_mode(in,tm,r)

%
% output a structure res.alpha, res.beta, res.delta, res.Gamma, res.Psi, and res.Omega
% containing posterior modes
%
post_i = 1;
for i=1:tm.save_draws;
   %
   % for each i compute the log prior density
   %
   lpr = logprior_rank(in.posterior(i).delta,in.posterior(i).Gamma,in.posterior(i).Omega,in.posterior(i).alpha,in.posterior(i).beta,tm.n,r,tm.d,tm.prior_inf_deter,tm.rank(tm.n+1).Omega,tm.lambda_alpha,tm.prior.deter.mu,tm.prior.deter.sigma,tm.prior.shortrun.mu,tm.prior.shortrun.sigma);
   %
   % Now we compute the log value of the likelihood
   %
   log_like = loglikefcn(in.posterior(i).Omega,in.posterior(i).epsilon);
   %
   % the log value of the posterior is equal to the sum of all 4 terms (minus a constant that only depends on the data)
   %
   log_posterior = log_like+lpr;
   if i==1;
      max_posterior = log_posterior;
   else;
      if log_posterior>max_posterior;
         max_posterior = log_posterior;
         post_i = i;
      end;
   end;
end;

res.alpha = in.posterior(post_i).alpha;
res.beta = in.posterior(post_i).beta;
res.delta = in.posterior(post_i).delta;
res.Gamma = in.posterior(post_i).Gamma;
res.Psi = [res.delta res.Gamma];
res.Omega = in.posterior(post_i).Omega;
res.max_evalue = in.posterior(post_i).max_evalue;
res.log_posterior = max_posterior;
res.log_like = loglikefcn(in.posterior(post_i).Omega,in.posterior(post_i).epsilon);
res.log_prior = logprior_rank(in.posterior(post_i).delta,in.posterior(post_i).Gamma,in.posterior(post_i).Omega,in.posterior(post_i).alpha,in.posterior(post_i).beta,tm.n,r,tm.d,tm.prior_inf_deter,tm.rank(tm.n+1).Omega,tm.lambda_alpha,tm.prior.deter.mu,tm.prior.deter.sigma,tm.prior.shortrun.mu,tm.prior.shortrun.sigma);

%
% end of posterior_rank_mode.m
%
