function print_residual_analysis(tm,curr_ini,epsilon,beta_df,alpha_df,my_df)

fout = fopen(tm.outputfile,'at');
%
sp_str = spacestr(curr_ini.decimals-2);
if curr_ini.restat==1;
   [residstats,residcorrmat] = residstat(epsilon,tm.Z0);
   if curr_ini.texoutputformat>=2;
      fprintf(fout,['\\subsection*{Residual analysis}\n\n\\header{For $r$=' num2str(tm.r) ', lags=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.r*tm.n-alpha_df,'%0.0f') '}\n\n']);
      fprintf(fout,'\\begin{tabular}{rrrrrrrr}\n');
      fprintf(fout,'Equation & Mean & Std.Dev & Skewness & Kurtosis & Min & Max & $R^2$ \\\\\n');
      for i=1:tm.n;
         fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],residstats(i,1),residstats(i,2),residstats(i,3),residstats(i,4),residstats(i,5),residstats(i,6),residstats(i,7));
      end;
      fprintf(fout,'\\end{tabular}\n\n\\header{Estimated residual correlations:}\n\n');
      myprintstr = ['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'];
      r_str = 'rr';
      for i=2:tm.n;
         myprintstr = [myprintstr ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f'];
         r_str = [r_str 'r'];
      end;
      myprintstr = [myprintstr ' \\\\\n'];
      fprintf(fout,['\\begin{tabular}{' r_str '}\n']);
      for i=1:tm.n;
         fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & ' myprintstr],residcorrmat(:,i));
      end;
      fprintf(fout,'\\end{tabular}\n\n\\ruler\n\n%%==============================================================================\n\n');
   else;
      fprintf(fout,['RESIDUAL ANALYSIS\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.r*tm.n-alpha_df,'%0.0f') ') \n\n']);
      fprintf(fout,['Equation     Mean ' sp_str 'Std.Dev ' sp_str ' Skew ' sp_str '  Kurt ' sp_str '  Min  ' sp_str '  Max  ' sp_str '   R2\n\n']);
      for i=1:tm.n;
         fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],residstats(i,1),residstats(i,2),residstats(i,3),residstats(i,4),residstats(i,5),residstats(i,6),residstats(i,7));
      end;
      fprintf(fout,'\nEstimated residual correlations:\n\n');
      myprintstr = ['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'];
      for i=2:tm.n;
         myprintstr = [myprintstr '  %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'];
      end;
      myprintstr = [myprintstr '\n'];
      for i=1:tm.n;
         fprintf(fout,[tm.myvars(i,:) tm.mv2add myprintstr],residcorrmat(:,i));
      end;
      fprintf(fout,'\n===============================================================================\n\n');
   end;
end;
if curr_ini.akaike==1;
   [aic,fpe,hq,sc] = infocrit(epsilon,my_df);
   fml = fml_crit(epsilon,tm.n+size(tm.Z1,1)+size(tm.Z2,1),tm.T-my_df,tm.n+size(tm.Z1,1)+size(tm.Z2,1)-my_df);
   if curr_ini.texoutputformat>=2;
      fprintf(fout,['\\subsection*{Information criteria}\n\n\\header{For $r$=' num2str(tm.r) ', lags=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '} \n\n']);
      fprintf(fout,'\\begin{tabular}{rrrrr}\n');
      fprintf(fout,'AIC & log(FPE) & HQ & SC & FML \\\\\n');
      fprintf(fout,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],aic,fpe,hq,sc,fml);
      fprintf(fout,'\\end{tabular}\n\n\\ruler\n\n%%==============================================================================\n\n');
   else;
      fprintf(fout,['INFORMATION CRITERIA\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n']);
      fprintf(fout,['\n     AIC   ' sp_str '     log(FPE)    ' sp_str '   HQ      ' sp_str '     SC     ' sp_str '      FML\n\n']);
      fprintf(fout,['%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     %' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     %' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     %' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     %' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],aic,fpe,hq,sc,fml);
      fprintf(fout,'\n===============================================================================\n\n');
   end;
end;
fclose(fout);

%
% end of print_residual_analysis.m
%
