function print_weakexo(tm,curr_ini,beta,alpha,epsilon,Sigma_theta,beta_df,alpha_df,local_df,aind)

fout = fopen(tm.outputfile,'at');
%
c_ind = 0;
if (isfield(tm,'restrict'))&(size(tm.restrict,2)==3);
   c_ind = tm.restrict(1,3);
end;
[results,degfree] = weakexotest(alpha,beta,epsilon,tm.Z1,tm.Z2,local_df,aind,tm.modelsdir,tm.modelfile,Sigma_theta,c_ind,tm.Psi,tm.p,tm.pe,tm.d,tm.q1,tm.q0);
%
if curr_ini.texoutputformat>=2;
   fprintf(fout,['\\subsection*{Weak exogeneity tests}\n\n\\header{For $r$=' num2str(tm.r) ', lags=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '}\n\n']);
   fprintf(fout,'\\header{Wald-type test statistic}\n\n');
   fprintf(fout,'\\begin{tabular}{ll}\n');
   fprintf(fout,'$H_0$: & $\\alpha$ in equation $k$ is zero \\\\\n');
   fprintf(fout,'$H_A$: & $\\alpha$ in equation $k$ is not zero \\\\[2mm]\n');
   fprintf(fout,'\\end{tabular}\n\n\\begin{tabular}{rrrr}\n');
   if curr_ini.sscorrect==0;
      fprintf(fout,'$k$ & df & W & $p$-value \\\\\n');
      for i=1:tm.n;
         if degfree(i,1)>0;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],degfree(i,1),results(i,1),results(i,2));
         else;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & \\multicolumn{3}{l}{Not computed} \\\\\n']);
         end;
      end;
   else;
      fprintf(fout,'$k$ & df & F & $p$-value \\\\\n');
      for i=1:tm.n;
         if degfree(i,1)>0;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],degfree(i,1),degfree(i,2),results(i,1),results(i,2));
         else;
            fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') tm.mv2add '      Not computed\n']);
         end;
      end;
   end;
   fprintf(fout,'\\end{tabular}\n\n\\ruler\n\n%%==============================================================================\n\n');
else;
   fprintf(fout,['WEAK EXOGENEITY TESTS\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n\n']);
   fprintf(fout,'  Wald-type test statistic\n');
   fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
   fprintf(fout,'Null hypothesis:        alpha in equation k is zero\n');
   fprintf(fout,'Alternative hypothesis: alpha in equation k is not zero\n\n');
   if curr_ini.sscorrect==0;
      fprintf(fout,'Equation          df         W          p-value\n\n');
      for i=1:tm.n;
         if degfree(i,1)>0;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '         %1.0f %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],degfree(i,1),results(i,1),results(i,2));
         else;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '         Not computed\n']);
         end;
      end;
   else;
      fprintf(fout,'Equation          df           F          p-value\n\n');
      for i=1:tm.n;
         if degfree(i,1)>0;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '      (%1.0f,%1.0f) %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],degfree(i,1),degfree(i,2),results(i,1),results(i,2));
         else;
            fprintf(fout,[tm.myvars(i,:) tm.mv2add '      Not computed\n']);
         end;
      end;
   end;
   fprintf(fout,'\n===============================================================================\n\n');
end;
fclose(fout);

%
% end of print_weakexo.m
%
