function [lpos,axpos] = getposition(legh,ha,legendpos,llen,lhgt)
%GETPOS Get position vector from legendpos code
stickytol=1;
cap=get(ha,'position');
edge = 5; % 5 Point edge

if length(legendpos)==4,
  % Keep the top at the same place
  Pos = [legendpos(1) legendpos(2)+legendpos(4)-lhgt];
else
  switch legendpos,
    case 0,
       Pos = lscan(legh,ha,llen,lhgt,0,stickytol,-1);
    case 1,
       Pos = [cap(1)+cap(3)-llen-edge cap(2)+cap(4)-lhgt-edge];
    case 2,
       Pos = [cap(1)+edge cap(2)+cap(4)-lhgt-edge];
    case 3,
       Pos = [cap(1)+edge cap(2)+edge];
    case 4,
       Pos = [cap(1)+cap(3)-llen-edge cap(2)+edge];
    otherwise
       Pos = -1;
  end
end
if isequal(Pos,-1)
  axpos=[cap(1) cap(2) cap(3)-llen-.03 cap(4)];
  lpos=[cap(1)+cap(3)-llen+edge cap(4)+cap(2)-lhgt llen lhgt];
  if any(axpos<0) | any(lpos<0),
    warning('Insufficient space to draw legend.')
    if any(axpos<0), axpos = []; end
  end
else
  axpos=[];
  lpos=[Pos(1) Pos(2) llen lhgt];
end

%
% end of getposition.m
%
