function show_recursive_rank_marglike(rec_marg_like,cm,curr_ini)

realscrsz = get(0,'ScreenSize');
thispos = [(realscrsz(3)-550)/2-22 (realscrsz(4)-360)/2+22];
stats = [];
file_names = '';
plot_handles = [];
cbsv = cbsval(cm.cbs);
%
% Using a patch to display the confidence region
%
if curr_ini.colors==1;
   colorstr = [0 0 1];
   colorstr3 = (1/255)*[255 255 177];
else;
   colorstr = [0 0 0];
   colorstr3 = [0.6 0.6 0.6];
end;
for i=1:cm.n+1;
   thispos = [thispos(1,1)+22 thispos(1,2)-22];
   if thispos(1,1)>(realscrsz(3)-550);
      thispos = [0 realscrsz(4)-430];
   end;
   if thispos(1,2)>(realscrsz(4)-430);
      thispos = [0 realscrsz(4)-430];
   elseif thispos(1,2)<32;
      thispos = [0 realscrsz(4)-430];
   end;
   myplot = figure('Units','pixels', ...
      'Position',[thispos 550 360], ...
      'Menubar','none', ...
      'Toolbar','none', ...
      'NumberTitle','off', ...
      'Visible','off', ...
      'Name',['Recursive Log Marginal Likelihood - rank ' num2str(i-1)]);
   %
   %
   % obey centering and filling defaults
   %
   setfigureproperties(myplot);
   %
   %
   if (i>1)&(i<=cm.n);
      u_val = rec_marg_like(i).log_marg_like+(cbsv*rec_marg_like(i).nse_marglike);
      l_val = rec_marg_like(i).log_marg_like-(cbsv*rec_marg_like(i).nse_marglike);
      %
      % plot the upper and lower bounds as a patch
      %
      my_p = patch([(200:1:cm.save_draws) reverse((200:1:cm.save_draws))],[u_val(1,200:cm.save_draws) reverse(l_val(1,200:cm.save_draws))],colorstr3);
      set(my_p,'FaceColor',colorstr3,'EdgeColor',colorstr3,'Tag','confpatch','LineWidth',1);
      hold('on');
      %
      % create a horizontal zero line if necessary
      %
      y_lim = get(gca,'Ylim');
      if (y_lim(1,1)<0)&(y_lim(1,2)>0);
         plot([200 cm.save_draws],[0 0],'-','LineWidth',1,'Color',[0 0 0]);
         hold('on');
      end;
      %
      % plot the actual data
      %
      plot((200:1:cm.save_draws),rec_marg_like(i).log_marg_like(1,200:cm.save_draws),'-','LineWidth',1,'Color',colorstr,'Tag',['rank-marg-like-' num2str(i-1,'%0.0f')]);
      set(gca,'YLim',y_lim);
   else;
      %
      % plot the data
      %
      plot((200:1:cm.save_draws),rec_marg_like(i).log_marg_like*ones(1,cm.save_draws-199),'-','LineWidth',1,'Color',colorstr,'Tag',['rank-marg-like-' num2str(i-1,'%0.0f')]);
   end;
   hold('on');
   set(gca,'XLim',[200 cm.save_draws],'Layer','top');
   %
   if (i>1)&(i<=cm.n);
      setaxesfonts('Title',['Log marginal likelihood for rank ' num2str(i-1) ' with ' num2str(cm.cbs) ' % numerical confidence bands'],'XLabel','Number of saved draws','YLabel',['ln p(Data|r=' num2str(i-1,'%0.0f') ')']);
   else;
      setaxesfonts('Title',['Log marginal likelihood for rank ' num2str(i-1) ],'XLabel','Number of saved draws','YLabel',['ln p(Data|r=' num2str(i-1,'%0.0f') ')']);
   end;
   toolbar_fcn(gca);
   hold('off');
   if curr_ini.external==0;
      plot_handles = [plot_handles myplot];
   else;
      file = [cm.outputdir 'rank-marg-like-' num2str(i-1,'%0.0f')];
      mstat = autosavefigure(myplot,file);
      stats = [stats mstat];
      file_names = strvcat(file_names,file);
   end;
end;

if (curr_ini.external==1)&(isempty(stats)==0);
   for i=1:size(stats,2);
      if stats(i)==0;
         autoshowfigure(strtrim(file_names(i,:)));
      end;
   end;
elseif curr_ini.external==0;
   for i=1:size(plot_handles,2);
      set(plot_handles(1,i),'Visible','on');
   end;
end;

%
% end of show_recursive_rank_marglike.m
%
