function show_residual_analysis(fig_handle,tm,ind)

set(fig_handle,'Visible','off');
drawnow;
curr_ini = find_inisettings;
res_str = '';
if ind==1;
   res_str = ' restricted';
end;
realscrsz = get(0,'ScreenSize');
%
% Compute the log-likelihood value
%
[lnl,ldOmega] = loglike(tm.epsilon);
[residstats,residcorrmat] = residstat(tm.epsilon,tm.Z0);
[aic,fpe,hq,sc] = infocrit(tm.epsilon,tm.df);
fml = fml_crit(tm.epsilon,tm.n+size(tm.Z1,1)+size(tm.Z2,1),tm.T-tm.df,tm.n+size(tm.Z1,1)+size(tm.Z2,1)-tm.df);
corrtext = strvcat(' ',['RESIDUAL ANALYSIS & INFORMATION CRITERIA (for' res_str ' rank=' num2str(tm.r) ')']);
numchar = size(corrtext,2);
addcorr = '';
for i=1:numchar;
   addcorr = strcat(addcorr,'=');
end;
corrtext = strvcat(corrtext,addcorr,' ');
corrtext = strvcat(corrtext,'Value of the maximized log-likelihood function:',' ',['   lnL(lags=' num2str(tm.p) ',rank=' num2str(tm.r) ')=' num2str(lnl,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])],' ');
corrtext = strvcat(corrtext,['   ln(det(Omega))=' num2str(ldOmega,['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'])],' ');
%
% Add Akaike info
%
sp_str = spacestr(curr_ini.decimals-2);
prt_val = ['%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'];
corrtext = strvcat(corrtext,['    AIC    ' sp_str '   log(FPE)   ' sp_str '   HQ     ' sp_str '     SC     ' sp_str '     FML'],' ');
corrtext = strvcat(corrtext,sprintf([prt_val '    ' prt_val '    ' prt_val '    ' prt_val '    ' prt_val],aic,fpe,hq,sc,fml),' ');
corrtext = strvcat(corrtext,['Equation        Mean ' sp_str ' Std.Dev ' sp_str 'Skewness ' sp_str 'Kurtosis ' sp_str ' Min  ' sp_str '   Max   ' sp_str '   R2'],' ');
prt_val = ['%' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f'];
for i=1:tm.n;
   out = sprintf([' %s%s  ' prt_val '  ' prt_val '  ' prt_val '   ' prt_val '  ' prt_val '  ' prt_val '  ' prt_val],tm.myvars(i,:),tm.mv2add,residstats(i,1),residstats(i,2),residstats(i,3),residstats(i,4),residstats(i,5),residstats(i,6),residstats(i,7));
   corrtext = strvcat(corrtext,out);
end;
corrtext = strvcat(corrtext,' ','Estimated residual correlations:',' ');
prt_str = '';
for i=1:tm.n;
   prt_str = [prt_str ' ' prt_val];
end;
for i=1:tm.n;
   corrtext = strvcat(corrtext,sprintf([' %s  ' prt_str],tm.myvars(i,:),residcorrmat(:,i)));
end;
corrtext = strvcat(corrtext,' ');
textgui(corrtext,'Residual Analysis and Information Criteria',[(realscrsz(3)-750)/2 (realscrsz(4)-450)/2 750 450],'Results',38);
set(fig_handle,'Visible','on');
drawnow;

%
% end of show_residual_analysis.m
%


