function states = var_comb(c)

%
% for integers ranging from 1 to c, the function
% returns all unique combinations of the integers
% and zero elements.
%
% Example: c = 3
%
% states = [ 0     0     3
%            0     2     0
%            0     2     3
%            1     0     0
%            1     0     3
%            1     2     0
%            1     2     3
%
% By removing the zeros we get all combinations of the
% numbers from 1 to 3. To do so one may pick one row at
% a time, e.g.
%
%  stat_i = states(i,:);
%
% where i is an index running from 1 to (2^c)-1, i.e.
% the number of rows of states. Then
%
% num_i = stat_i(stat_i~=0);
%
% gives a vector num_i with the non-zero values from
% row i of states.
%

num_c = (2^c);

qs = 5;
q = 32;
statesel = kron(eye(2),ones(1,2^(c-1)));
i = 1;
while i <= c-1;
   statesi = kron(ones(1,2^i),kron(eye(2),ones(1,2^(c-1-i))));
   statesel = [statesel;statesi];
   i = i+1;
end;
comsel = zeros(2*c,2*c);
i = 1;
while i <= c;
   j = 1;
   while j <= 2;
      comsel(j+2*(i-1),i+c*(j-1)) = 1;
      j = j+1;
   end;
   i = i+1;
end;
statesel = comsel'*statesel;
statesej = reshape(statesel(:,1),c,2);
state1 = (1:1:2)';
states = statesej*state1;
j = 2;
while j <= num_c;
   statesej = reshape(statesel(:,j),c,2);
   states = [states (statesej*state1)];
   j = j+1;
end;
K = commutation(2,2);
states = (states'-ones(num_c,c)) .* (ones(num_c,1)*(1:1:c));

states = states(2:num_c,:);

%for i=1:num_c-1;
%   check = states(i,:);
%   disp(check(check~=0));
%end;

%
% end of var_comb.m
%

