function [vardec,std_vardec] = var_decomp(n,ir,Sigma_theta,Sigma_B0,partial)

ir = ir(:,1:size(ir,2)-1);
h = size(ir,2);

%
% compute the variance decompositions and their standard errors
%

vardec = zeros(n*n,h);
std_vardec = zeros(n*n,h);
dvn = diag(vec(eye(n)));

for i=1:h;
   myir(i).R = vecinv(ir(:,i),n);
   myir(i).R2 = (myir(i).R*myir(i).R') .* eye(n);
   myir(i).sumR2 = myir(i).R2;
   myir(i).Rsq = myir(i).R .* myir(i).R;
   myir(i).sumRsq = myir(i).Rsq;
   if i>1;
      myir(i).sumR2 = myir(i).sumR2+myir(i-1).sumR2;
      myir(i).sumRsq = myir(i).sumRsq+myir(i-1).sumRsq;
   end;
   myir(i).vd = inverse(myir(i).sumR2)*myir(i).sumRsq;
   vardec(:,i) = vec(myir(i).vd);
   myir(i).dvr = diag(vec(myir(i).R));
   myir(i).dvnr = dvn*kron(myir(i).R,eye(n));
   myir(i).theta = zeros(n*n,size(partial(1).theta,2));
   myir(i).B_0 = zeros(n*n,size(partial(1).B_0,2));
   for j=1:i;
      myvd(j).vdadj = (myir(j).dvr-(kron(myir(i).vd',eye(n))*myir(j).dvnr));
      myvd(j).theta = myvd(j).vdadj*partial(j).theta;
      myvd(j).B_0 = myvd(j).vdadj*partial(j).B_0;
      myir(i).theta = myir(i).theta+myvd(j).theta;
      myir(i).B_0 = myir(i).B_0+myvd(j).B_0;
   end;
   myir(i).theta = 2*kron(eye(n),inverse(myir(i).sumR2))*myir(i).theta;
   myir(i).B_0 = 2*kron(eye(n),inverse(myir(i).sumR2))*myir(i).B_0;
   %
   vcv = (myir(i).theta*Sigma_theta*myir(i).theta')+(myir(i).B_0*Sigma_B0*myir(i).B_0');
   ste_vd = sqrt(abs(diag(vcv)));
   %
   % adjust ste_vd for small numbers
   %
   for j=1:n*n;
      if ste_vd(j,1)<1.0e-008;
         ste_vd(j,1) = 0;
      end;
   end;
   std_vardec(:,i) = ste_vd;
end;

%
% end of var_decomp.m
%
