function [m,out1,out2,thissheet,action_sheet] = xlsread_fcn(filename, arg)

%
% where arg is a sheetname
%

args = nargin;

if nargin==1;
   arg = '';
end;
action = '';
if nargout==5;
   action_sheet = '';
end;

%
% Check the file
%

[fok,sheets] = myxlsfinfo(filename);

if isempty(fok)==1;
   m = [];
   out1 = '';
   out2 = '';
   thissheet = '';
   return;
else;
   if nargin==1;
      if size(sheets,1)>1;
         args = 2;
         mysheets = sheets{1};
         for i=2:size(sheets,1);
            mysheets = [mysheets '|' sheets{i}];
         end;
         [action,selsheet] = sheetdlg(mysheets,filename);
         if strcmp(action,'Cancel')==1;
            m = [];
            out1 = '';
            out2 = '';
            thissheet = '';
            if nargout==5;
               action_sheet = action;
            end;
            return;
         else;
            arg = sheets{selsheet};
         end;
      end;
   end;
end;

if args==1;
   [m,n] = myxlsread(filename);
elseif args==2;
   if strcmp(arg,'')==1;
      [m,n] = myxlsread(filename);
   else;
      [m,n] = myxlsread(filename,arg);
   end;
end;

out1 = '';
out2 = '';

if (size(n)==[1 1]);
   out1 = n{1,1};
   if nargout==4;
      thissheet = arg;
   end;
   return;
end;

%
% remove zero row and column from m
%

[n1 n2] = size(n);
row = [];
col = [];
checkcol = [];
checkrow = [];

if (n1>0)&(n2>0);
   for i=1:n2-1;
      checkrow{1,i} = [];
   end;
   for i=1:n1-1;
      checkcol{i,1} = [];
   end;
   %
   % locating a row without empty elements
   %
   if n2>1;
      for i=1:n1;
         for j=1:n2;
            if j==1;
               check = n(i,2:n2);
            elseif j==n2;
               check = n(i,1:n2-1);
            else;
               check = [n(i,1:j-1) n(i,j+1:n2)];
            end;
            if isequal(check,checkrow)==0;
               row = i;
               break;
            end;
         end;
         if isempty(row)==0;
            break;
         end;
      end;
   end;
   %
   % locating a column without empty elements
   %
   if n1>1;
      for i=1:n2;
         for j=1:n1;
            if j==1;
               check = n(2:n1,i);
            elseif j==n1;
               check = n(1:n1-1,i);
            else;
               check = [n(1:j-1,i);n(j+1:n1,i)];
            end;
            if isequal(check,checkcol)==0;
               col = i;
               break;
            end;
         end;
         if isempty(col)==0;
            break;
         end;
      end;
   end;
end;



%
% if n only contains one row, we need to check if it includes the entry date. if it
% does we need to remove the column of m coreesponding to date and enter it into n
%

if (size(n,1)==1)&(size(n,2)>=1);
   b_fix = 0;
   for i=1:size(n,2);
      if strcmp(lower(strtrim(n{1,i})),'date')==1;
         b_fix = i;
         break;
      end;
   end;
   if b_fix>0;
      date_data = m(:,b_fix);
      %
      % check if yearly data
      %
      b_status = ifyearly(date_data);
      if b_status==0;
         if b_fix==1;
            m = m(:,2:size(n,2));
         elseif b_fix==size(n,2);
            m = m(:,1:size(n,2)-1);
         else;
            m = [m(:,1:b_fix-1) m(:,b_fix+1:size(n,2))];
         end;
         %
         % now we need to enter date_data into n. we first create a cell array
         % with empty elements
         %
         new_n = cell_fcn(size(m,1),size(n,2));
         for i=1:size(m,1);
            new_n{i,b_fix} = [num2str(date_data(i,1)) 'Y'];
         end;
         n = [n;new_n];
         col = b_fix;
      end;
   end;
end;


if nargout>1;
   if (n1>0)&(n2>0);
      %
      % retrieve 0,1, or 2 text strings from n
      %
      if (isempty(row)==0)&(isempty(col)==0);
         n{row,col} = [];
      end;
      if isempty(row)==0;
         for i=1:n2;
            if isstr(n{row,i})==1;
               out1 = [out1 ' ' n{row,i}];
            end;
         end;
         out1 = out1(1,2:size(out1,2));
      end;
      if isempty(col)==0;
         for i=1:n1;
            if isstr(n{i,col})==1;
               dtstri = n{i,col};
               dtstri = strrep(dtstri,':',' ');
               dtstri = strrep(dtstri,'-',' ');
               dtstri = strrep(dtstri,'#',' ');
               dtstri = strrep(dtstri,'Q',' ');
               dtstri = strrep(dtstri,'M',' ');
               dtstri = strrep(dtstri,'Y','');
               dtstri = strrep(dtstri,'y','');
               dtstri = strrep(dtstri,'q',' ');
               dtstri = strrep(dtstri,'m',' ');
               dtstri = strrep(dtstri,'@',' ');
               dtstri = strrep(dtstri,'(',' ');
               dtstri = strrep(dtstri,')','');
               dtstri = strrep(dtstri,'[',' ');
               dtstri = strrep(dtstri,']','');
               dtstri = strrep(dtstri,'{',' ');
               dtstri = strrep(dtstri,'}','');
               out2 = strvcat(out2,dtstri);
            end;
         end;
      end;
   end;
end;

if nargout>=4;
   thissheet = arg;
end;

if nargout==5;
   action_sheet = action;
end;

%
% end of xlsread_fcn.m
%
